#include<cstdio>
#include<string>

struct word
{
   char beg, end;
   int begn, endn, bestin, ol;
   word(){begn=endn=bestin=0; beg=end=0;}
   void init(){begn=endn=bestin=0; beg=end=0;}
   int read()
   {
      char s[64];
      if(scanf("%s", s)==EOF) return 0;
      int i, n=strlen(s); ol=n;
      /*Get bestin*/
      int t=1, bst=0;
      for(i=1; i<n; i++)
         if(s[i]==s[i-1]) t++;
         else { bst=t; t=1; }
      bestin=bst;
      /*Got bestin*/
      /*Bet beg, end*/
      beg=s[0]; begn=1;
      i=1;
      while(i<n && s[i]==beg) { i++; begn++; }
      end=s[n-1]; endn=1;
      i=n-2;
      while(i>=0 && s[i]==end){ i--; endn++; }
      /*Got beg, end */
      return 1;
   }
};

struct Words
{
   word bwith[128];
   word ewith[128];
   int fullof[128];
   Words()
   {
      for(int i=0; i<128; i++)
      {
         bwith[i].init();
         ewith[i].init();
         fullof[i]=0;
      }
   }
   void add(word w)
   {
      if(w.beg==w.end && w.begn==w.ol) { fullof[w.beg]+=w.begn; return; }
      if(bwith[w.beg].begn<w.begn) bwith[w.beg]=w;
      if(ewith[w.end].endn<w.endn) ewith[w.end]=w;
   }
} words;

inline int best(char with)
{
   int s=0;
   s+=words.bwith[with].begn;
   s+=words.ewith[with].endn;
   s+=words.fullof[with];
   return s;
}

int main()
{
   word t;
   int max=0, p;
   while(t.read())
   {
      if(t.bestin>max) max=t.bestin;
      words.add(t);
   }
   for(char c='A'; c<='Z'; c++)
   {
      p=best(c);
      if(p>max) max=p;
   }
   printf("%d", max);
   return 0;
}
