#include <iostream>
#include <stack>
using namespace std;

struct list
{
       int id;
       stack<int> card;
       list* prev;
       list* next;
};

int n, k;
int razd[1024][1024];
list* first;
list* last;

void show( list* i )
{
     if ( i -> card.empty() )
     {
          cout << "-1" << endl;
          return;
     }
     
     cout << i -> card.top();
     i -> card.pop();

     while ( i -> card.empty() == 0 )
     {
           cout << " " << i -> card.top();
           i -> card.pop();
     }
     cout << endl;
}

void match( list* i, list* j )
{
     if ( i -> card.top() < j -> card.top() )
     {
          j -> card.push( i -> card.top() );
          i -> card.pop();
     }
     else if ( i -> card.top() > j -> card.top() )
     {
          i -> card.push( j -> card.top() );
          j -> card.pop();
     }
}

int main()
{
    int i, j;
    list* p;
    list* q;
    
    cin >> n >> k;
    
    for ( i = 1; i <= k; i++ )
        for ( j = 1; j <= n; j++ )
            cin >> razd[i][j];
    
    first = new list;
    last = new list;
    p = new list;
    p -> prev = first;
    first -> next = p;
    p -> id = 1;
    for ( i = 2; i <= n; i++ )
    {
        q = new list;
        q -> prev = p;
        p -> next = q;
        p = q;
        p -> id = i;
    }
    p -> next = last;
    last -> prev = p;
    
    for ( i = 1; i <= k; i++ )
    {
        p = first -> next;
        for ( j = 1; j <= n; j++ )
        {
            p -> card.push( razd[i][j] );
            p = p -> next;
        }
        
        p = first -> next;
        match( p, p -> next );
        
        q = p -> next;
        first -> next = q;
        q -> prev = first;
        p -> next = last;
        q = last -> prev;
        q -> next = p;
        p -> prev = q;
        last -> prev = p;
    }
    
    p = first -> next;
    show( p );
    
    while ( p -> next != last )
    {
          q = p -> next;
          delete p;
          p = q;
    }
    delete p;
    delete first;
    delete last;
    
    return 0;
}
